Attribute VB_Name = "MMC"
' Functions for emulating MMCs. Select8KVROM and the
' like
' 16.07.00
Public CurrVr As Byte
Public PrgSwitch1 As Byte
Public PrgSwitch2 As Byte
Public SpecialWrite6000 As Boolean

Public bank0(2047) As Byte ' RAM
Public bank6(8191) As Byte ' SaveRAM
Public bank8(8191) As Byte '8-E are PRG-ROM.
Public bankA(8191) As Byte
Public bankC(8191) As Byte
Public bankE(8191) As Byte

Public Sub MMC3_Sync()
If Swap Then
    reg8 = &HFE
    regA = PrgSwitch2
    regC = PrgSwitch1
    regE = &HFF
Else
    reg8 = PrgSwitch1
    regA = PrgSwitch2
    regC = &HFE
    regE = &HFF
End If
SetupBanks
End Sub

Public Function MaskBankAddress(bank As Byte)
Dim i As Byte: i = &HFF
Do While ((bank And i) >= (PrgCount * 2))
    i = i \ 2
Loop
MaskBankAddress = (bank And i)
End Function
Public Function MaskVROM(page As Byte, mask As Integer)
    MaskVROM = (page And (mask - 1))
End Function
Public Sub SetupBanks()
    reg8 = MaskBankAddress(reg8)
    regA = MaskBankAddress(regA)
    regC = MaskBankAddress(regC)
    regE = MaskBankAddress(regE)
    
    MemCopy bank8(0), gameImage(reg8 * &H2000&), &H2000&
    MemCopy bankA(0), gameImage(regA * &H2000&), &H2000&
    MemCopy bankC(0), gameImage(regC * &H2000&), &H2000&
    MemCopy bankE(0), gameImage(regE * &H2000&), &H2000&
End Sub
Public Sub Select8KVROM(value As Byte)
    value = MaskVROM(value, CInt(ChrCount))
    MemCopy VRAM(0), VROM(value * &H2000&), &H2000&
End Sub
Public Sub Select4KVROM(value As Byte, bank As Byte)
    value = MaskVROM(value, CInt(ChrCount * 2))
    MemCopy VRAM(bank * &H1000&), VROM(value * &H1000&), &H1000&
End Sub
Public Sub Select2KVROM(value As Byte, bank As Byte)
    value = MaskVROM(value, CInt(ChrCount * 4))
If Mapper = 4 Then
    MemCopy VRAM(MMC3_ChrAddr Xor (bank * &H800&)), VROM(value * &H800&), &H800&
Else
    MemCopy VRAM(bank * &H800&), VROM(value * &H800&), &H800&
    'MemCopy DirtyChar(0), DirtyChar2(0), &H3C0
End If
End Sub
Public Sub Select1KVROM(value As Byte, bank As Byte)
value = MaskVROM(value, ChrCount * 8)
If Mapper = 4 Then
    MemCopy VRAM(MMC3_ChrAddr Xor (bank * &H400&)), VROM(value * &H400&), &H400&
Else
    MemCopy VRAM(bank * &H400&), VROM(value * &H400&), &H400&
End If
End Sub
