Attribute VB_Name = "NESHardware"
'+====================================================+'
'| basicNES 2k                                        |'
'| by Don Jarrett, 2000                               |'
'| Always a source/binary release                     |'
'| http://home.att.net/~r.jarrett/bNES.html           |'
'+====================================================+'

' NES Hardware defines
Public PPU_Control1 As Byte ' $2000
Public PPU_Control2 As Byte ' $2001
Public PPU_Status As Byte ' $2002
Public SpriteAddress As Byte ' $2003
Public PPUAddressHi As Long ' $2006, 1st write
Public PPUAddress As Long ' $2006
Public PPU_AddressIsHi As Boolean
Public VRAM(&H3FFF) As Byte, VROM() As Byte  ' Video RAM
Public SpriteRAM(&HFF) As Byte
Public Sound(0 To &H15) As Byte

Public PrgCount As Byte, PrgCount2 As Long, ChrCount As Byte, ChrCount2 As Long

Public reg8 As Byte
Public regA As Byte
Public regC As Byte
Public regE As Byte

Public NESPal(&HF) As Byte

Public CPal

Public FrameSkip As Integer
Public Frames As Long

Public ScrollToggle As Byte
Public HScroll As Byte, VScroll As Integer ' $2005

Public Map15_BankAddr As Byte
Public Map15_SwapReg As Byte

' MMC3[Mapper #4] infos
Public MMC3_Command As Byte
Public MMC3_PrgAddr As Byte
Public MMC3_ChrAddr As Long
Public MMC3_IrqVal As Integer
Public MMC3_TmpVal As Byte
Public MMC3_IrqOn As Boolean

Public PatternTable As Long
Public NameTable As Long

Public bank_regs(16) As Byte

Public Const PPU_InVBlank = &H80
Public Const PPU_Sprite0 = &H40
Public Const PPU_SpriteCount = &H20
Public Const PPU_Ignored = &H10

Public reg8000 As Byte ' Needed for mapper #69.

Public AndIt As Byte, AndIt2 As Byte

Public data(4) As Byte, sequence As Integer, accumulator As Integer

Public Table

Public Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type
Public OpenFile As OPENFILENAME

Public ChrCnt As Byte, PrgCnt As Byte
Public FirstRead As Boolean ' First read to $2007 is invalid
Public Joypad1(7) As Byte, Joypad1_Count As Byte

Public Mapper As Byte, Mirroring As Byte, Trainer As Byte, FourScreen As Byte
Public MirrorXor As Integer
Public UsesSRAM As Boolean

Public Keyboard(255) As Byte

Public CPURunning As Boolean

Public Declare Sub MemCopy Lib "Kernel32" Alias "RtlMoveMemory" (Dest As Any, Src As Any, ByVal cb&)

Public MMC32_Switch As Byte

Public MMC16_Irq As Integer, MMC16_IrqOn As Byte

Public Type Sprite
    X As Integer
    Y As Integer
    TileNo As Byte
    Attrib As Byte
End Type
Public SpriteAddr As Integer

Public Pal(64) As Long

Public Sprites(63) As Sprite

Public Mapper40_IRQEnabled As Byte, Mapper40_IRQCounter As Byte

Public Type MMC2_latch
    lo_bank As Byte
    hi_bank As Byte
    state As Byte
End Type
Public latch1 As MMC2_latch
Public latch2 As MMC2_latch

' Other
Public Const VERSION = "basicNES 2000 v0 [debug level 1.41]"

Public Sub RenderSprites(scanline As Integer)
Dim TileRow As Byte, TileYOffset As Integer
Dim TileCounter As Integer, Color As Byte
Dim TileIndex As Byte, Byte1 As Byte, Byte2 As Byte
Dim H As Byte
Dim X1 As Byte
TileRow = scanline \ 8
TileYOffset = scanline Mod 8
If PPU_Control1 And &H20 Then
    H = 16
Else
    H = 8
End If
If PPU_Control1 And &H8 Then
    If H = 8 Then
        PatternTable = &H1000&
    End If
Else
    If H = 8 Then
        PatternTable = &H0
    End If
End If
Dim spr As Integer
Dim SpriteAddr As Integer
For spr = 63 To 0
    SpriteAddr = spr * 4
    X1 = SpriteRAM(SpriteAddr + 3)
    Y1 = SpriteRAM(SpriteAddr)
    If Y1 >= scanline - Y1 Then
    End If
Next spr
End Sub
Public Sub RenderScanline(scanline As Integer)
Dim TileRow As Byte, TileYOffset As Integer
Dim TileCounter As Integer, Color As Byte
Dim TileIndex As Byte, Byte1 As Byte, Byte2 As Byte
If scanline > 239 Then Exit Sub
Dim atrtab As Long
TileRow = (scanline \ 8) + VScroll
TileYOffset = scanline Mod 8
NameTable = &H2000& + (&H400& * (PPU_Control1 And &H3))
atrtab = NameTable + &H3C0
PatternTable = (PPU_Control1 And &H10) * &H100&
For TileCounter = 31 To 0 Step -1
    TileIndex = VRAM(NameTable + (TileCounter + TileRow * 32))
    Byte1 = VRAM(PatternTable + (TileIndex * 16) + TileYOffset)
    Byte2 = VRAM(PatternTable + (TileIndex * 16) + 8 + TileYOffset)
    Dim pixel As Integer
    For pixel = 0 To 7
        Color = 0
        If Byte1 And Table(pixel) Then Color = 1
        If Byte2 And Table(pixel) Then Color = Color + 2
        Dim LookUp As Byte, AddToCol As Byte
        LookUp = VRAM(atrtab + (TileCounter \ &H4&) + (TileRow \ &H4&) * &H8&)
        If ((((TileCounter And &H2) + (TileRow And &H2) * 2) And &H3) * 4&) Then
            AddToCol = ((LookUp \ 2 ^ (((TileCounter And &H2) + (TileRow And &H2) * 2)) And 3) * 4)
        End If
        'If ee Then Debug.Print ee, ff
        Color = Color + AddToCol
        frmNES.picScreen.PSet (TileCounter * 8 + (7 - pixel), scanline), Pal(VRAM(&H3F00 + Color) And &H3F)
    Next pixel
Next TileCounter
End Sub
Public Function Read6502(Address) As Byte

Select Case Address
    Case &H0 To &H1FFF
        Read6502 = bank0(Address And &H7FF)
    Case &H2002
        Dim ret As Byte
        ret = PPU_Status
        PPU_AddressIsHi = True
        ScrollToggle = 0
        PPU_Status = PPU_Status And &H3F
        Read6502 = ret
    Case &H2007
        If Mapper = 9 Then MMC2_latch PPUAddress
        PPUAddress = PPUAddress And &H3FFF&
        If FirstRead Then
            FirstRead = False
            Read6502 = VRAM(PPUAddress) ' TODO: Fix???
        Else
            FirstRead = True
            Read6502 = VRAM(PPUAddress)
            If (PPU_Control1 And &H4) Then
                PPUAddress = PPUAddress + 32
            Else
                PPUAddress = PPUAddress + 1
            End If
        End If
    Case &H4000& To &H4013&, &H4015&
        Read6502 = Sound(Address - &H4000&)
    Case &H4016
        Read6502 = Joypad1(Joypad1_Count)
        Joypad1_Count = (Joypad1_Count + 1) And 24
    Case &H4017
        ' to be added
    Case &H6000& To &H7FFF&
        If UsesSRAM Then
            Read6502 = bank6(Address And &H1FFF&)
        End If
    Case &H8000& To &HFFFF&
        Select Case (Address And &HE000&)
            Case &H8000&: Read6502 = bank8(Address And &H1FFF&)
            Case &HA000&: Read6502 = bankA(Address And &H1FFF&)
            Case &HC000&: Read6502 = bankC(Address And &H1FFF&)
            Case &HE000&: Read6502 = bankE(Address And &H1FFF&)
        End Select
End Select
End Function
Public Sub Write6502(Address, value As Byte)
'=========================================='
'           Write6502(Address,value)       '
'   Used to write values to the 6502's mem '
' and Mappers.                             '
'=========================================='
Select Case Address
    Case &H0 To &H1FFF: bank0(Address And &H7FF) = value
    Case &H2000: PPU_Control1 = value
    Case &H2001: PPU_Control2 = value
    Case &H2003: SpriteAddress = value
    Case &H2004
        SpriteRAM(SpriteAddress) = value
        SpriteAddress = (SpriteAddress + 1) And &HFF
    Case &H2005
        If PPU_AddressIsHi Then
            HScroll = value
        Else
            VScroll = value
        End If
    Case &H2006
        If PPU_AddressIsHi Then
            PPUAddressHi = value * &H100&
            PPU_AddressIsHi = False
        Else
            PPUAddress = PPUAddressHi + value
            PPU_AddressIsHi = True
        End If
    Case &H2007
        If Mapper = 9 Then MMC2_latch PPUAddress
        'Debug.Print "PPUAddress:$" & Hex$(PPUAddress), "Value:$" & Hex$(value)
        PPUAddress = PPUAddress And &H3FFF&
        VRAM(PPUAddress) = value
        If PPUAddress >= &H3F00& And PPUAddress <= &H3F1C Then
            VRAM(PPUAddress + 4) = value: VRAM(PPUAddress + 8) = value
            VRAM(PPUAddress + 12) = value: VRAM(PPUAddress + 16) = value
        End If
        If (PPUAddress And &H3000&) = &H2000& Then VRAM(PPUAddress Xor MirrorXor) = value
        If (PPU_Control1 And &H4) Then
            PPUAddress = PPUAddress + 32
        Else
            PPUAddress = PPUAddress + 1
        End If
    Case &H4000& To &H4013&
        Sound(Address - &H4000&) = value
    Case &H4014: MemCopy SpriteRAM(0), gameImage(value * &H100&), &H100&
    Case &H4015&: Sound(Address - &H4000&) = value
    Case &H4016: Joypad1_Count = &H0
    Case &H4017:
    Case &H6000& To &H7FFF&
        If SpecialWrite6000 = True Then
            MapperWrite Address, value
        ElseIf UsesSRAM Then
            If Mapper <> 69 Then bank6(Address And &H1FFF) = value
        End If
    Case &H8000& To &HFFFF&
        MapperWrite Address, value
    Case Else:
End Select

End Sub
Public Sub MMC3Write(value As Byte, Address)
Select Case Address
    Case &H8000&
        MMC3_Command = value And &H7
        If value And &H80 Then MMC3_ChrAddr = &H1000& Else MMC3_ChrAddr = 0
        If value And &H40 Then Swap = 1 Else Swap = 0
    Case &H8001&
        Select Case MMC3_Command
            Case 0: Select1KVROM value, 0: Select1KVROM value + 1, 1
            Case 1: Select1KVROM value, 2: Select1KVROM value + 1, 3
            Case 2: Select1KVROM value, 4
            Case 3: Select1KVROM value, 5
            Case 4: Select1KVROM value, 6
            Case 5: Select1KVROM value, 7
            Case 6: PrgSwitch1 = value: MMC3_Sync
            Case 7: PrgSwitch2 = value: MMC3_Sync
        End Select
    Case &HA000&: Mirroring = (value And &H1) + 1: MirrorXor = &H400& * 2 ^ Mirroring
    Case &HA001&: If value Then UsesSRAM = True Else UsesSRAM = False
    Case &HC000&: MMC3_IrqVal = value
    Case &HC001&: MMC3_TmpVal = value
    Case &HE000&: MMC3_IrqOn = False: MMC3_IrqVal = MMC3_TmpVal
    Case &HE001&: MMC3_IrqOn = True
End Select
End Sub
Public Sub MapperWrite(Address, value As Byte)
'===================================='
'       MapperWrite(Address,value)   '
' Selects/Switches Chr-ROM and Prg-  '
' ROM depending on the mapper. Based '
' on DarcNES.                        '
'===================================='
    Select Case Mapper
        Case 1: MMC1_Write Address, value
        Case 2
            reg8 = (value * 2)
            regA = reg8 + 1
            SetupBanks
        Case 3: Select8KVROM (value And AndIt)
        Case 4: MMC3Write value, Address ' this function is too big to store here...
        Case 7
            reg8 = (value And &HF) * 4
            regA = reg8 + 1
            regC = reg8 + 2
            regE = reg8 + 3
            SetupBanks
            Mirroring = (value And &H10)
            If Mirroring Then MirrorXor = &H800& Else MirrorXor = &H0
        Case 8
            reg8 = value And &HF8
            regA = reg8 + 1
            SetupBanks
            Select8KVROM value And &H7
        Case 9: MMC2Write Address, value
        Case 11
            reg8 = ((value And &HF) * 4)
            regA = reg8 + 1
            regC = reg8 + 2
            regE = reg8 + 3
            SetupBanks
            Select8KVROM (value And &HF0)
        Case 15
            Map15_BankAddr = (value And &H3F)
            Select Case (Address And &H3)
                Case &H0
                    map15_swapaddr = (value And &H80)
                    reg8 = Map15_BankAddr
                    regA = Map15_BankAddr + 1
                    regC = Map15_BankAddr + 2
                    regE = Map15_BankAddr + 3
                    SetupBanks
                Case &H1
                    Map15_SwapReg = (value And &H80)
                    regC = Map15_BankAddr
                    regE = Map15_BankAddr + 1
                    SetupBanks
                Case &H2
                    
                Case &H3
                    Map15_SwapReg = (value And &H80)
                    regC = Map15_BankAddr
                    regE = Map15_BankAddr + 1
                    SetupBanks
                    Mirroring = (value And &H40) \ &H40
                    Mirroring = Mirroring + 1
                    MirrorXor = Mirroring * &H400&
            End Select
        Case 16
            Select Case Address And &HD
                Case &H0 To &H7: Select1KVROM value, Address And &H7
                Case &H8: reg8 = value * 2: regA = reg8 + 1: SetupBanks
                Case &H9: Mirroring = value And &H3: MirrorXor = &H400& * 2 ^ Mirroring
                Case &HA: MMC16_IrqOn = value
                Case &HB: 'Debug.Print value
                Case &HC: 'Debug.Print value
                Case &HD: ' ?
            End Select
        Case 32
            Select Case Address
                Case &H8000& To &H8FFF&
                    If (MMC32_Switch And &H2) = 2 Then
                        regC = value
                        SetupBanks
                    Else
                        reg8 = value
                        SetupBanks
                    End If
                'Debug.Print "address:$" & Hex$(Address) & " value:$" & Hex$(value)
                Case &H9000& To &H9FFF&
                    Mirroring = (value And &H1) + 1: MirrorXor = &H400& * 2 ^ Mirroring
                    MMC32_Switch = value
                Case &HA000& To &HAFFF&
                    regA = value
                    SetupBanks
                Case &HBFF0& To &HBFF7
                    Select1KVROM value, Address And &H7
            End Select
        Case 33
            Select Case Address
                Case &H8000&: reg8 = value: SetupBanks
                Case &H8001&: regA = value: SetupBanks
                Case &H8002&: Select2KVROM value, 0
                Case &H8003&: Select2KVROM value, 2
                Case &HA000&: Select1KVROM value, 4
                Case &HA001&: Select1KVROM value, 5
                Case &HA002&: Select1KVROM value, 6
                Case &HA003&: Select1KVROM value, 7
                Case &HC000, &HC001, &HE000&
            End Select
        Case 34
            If Address >= &H6000& And Address <= &H7FFC& Then Exit Sub
            Select Case Address
                Case &H7FFD&
                    reg8 = value * 4
                    regA = reg8 + 1
                    regC = regA + 1
                    regE = regC + 1
                    SetupBanks
                Case &H7FFE&
                    Debug.Print "Map34: Chr-ROM Select - $" & Hex$(value) & " at $0000"
                    MemCopy VRAM(0), VROM(value * &H1000&), &H1000&
                Case &H7FFF&
                    Debug.Print "Map34: Chr-ROM Select - $" & Hex$(value) & " at $1000"
                    MemCopy VRAM(&H1000&), VROM(value * &H1000&), &H1000&
                Case &H8000& To &HFFFF&
                    reg8 = value * 4
                    regA = reg8 + 1
                    regC = regA + 1
                    regE = regC + 1
                    SetupBanks
            End Select
        Case 40
            Select Case (Address And &HE000&)
                Case &H8000&
                    Mapper40_IRQEnabled = 0
                    Mapper40_IRQCounter = 36
                Case &HA000&
                    ' IRQ enable
                    Mapper40_IRQEnabled = 1
                Case &HE000&
                    regC = value
                    SetupBanks
            End Select
        Case 66
            reg8 = (value \ 16) * 4
            regA = reg8 + 1
            regC = regA + 1
            regE = regC + 1
            SetupBanks
            Select8KVROM value And &H3
        Case 68
            Select Case Address
                Case &H8000&, &H9000&, &HA000&, &HB000&, &HC000&, &HD000&: Select2KVROM value, (Address - &H8000&) \ &H1000&
                Case &HE000&: MirrorXor = (value And &H3) * &H400&
                Case &HF000&: reg8 = (value * 2): regA = (value * 2) + 1: SetupBanks
            End Select
        Case 69
            Select Case Address
                Case &H8000&: reg8000 = value And &HF
                Case &HA000&
                    Select Case reg8000
                        Case 0 To 7: Select1KVROM value, reg8000
                        Case 8: value = MaskBankAddress(value): MemCopy bank6(0), gameImage(value * &H2000&), &H2000&
                        Case 9: reg8 = value
                        Case 10: regA = value
                        Case 11: regC = value
                        Case 12: MirrorXor = (value And &H3) * &H400&
                        Case 13: ' Not sure here either
                        Case 14, 15 ' Not sure about these.
                    End Select
            End Select
            SetupBanks
        Case 71
            Select Case Address
                Case &H8000& To &HBFFF&: ' Unknown
                Case &HC000& To &HFFFF&: reg8 = (value * 2): regA = (value * 2) + 1: SetupBanks
            End Select
        Case 78
            MMC78_Write Address, value
        Case 91
            Select Case Address
                Case &H6000& To &H6FFF&
                    Select Case Address And &H3
                        Case 0: Select2KVROM value, 0
                        Case 1: Select2KVROM value, 1
                        Case 2: Select2KVROM value, 2
                        Case 3: Select2KVROM value, 3
                    End Select
                Case &H7000& To &H7FFB&
                    Select Case Address And &H1
                        Case 0
                            reg8 = value
                            SetupBanks
                        Case 1
                            regA = value
                            SetupBanks
                    End Select
            End Select
    End Select
End Sub
Public Function LoadNES(filename As String) As Byte
'===================================='
'           LoadNES(filename)        '
' Used to Load the NES ROM/VROM to   '
' specified arrays, gameImage and    '
' VROM, then figures out what to do  '
' based on the mapper number.        '
'===================================='
Dim Header As String * 3

Dim i As Long
Dim ROMCtrl As Byte, ROMCtrl2 As Byte
Erase VRAM: Erase VROM: Erase gameImage: Erase bank8: Erase bankA
Erase bankC: Erase bankE: Erase bank0: Erase bank6
SpecialWrite6000 = False

If Dir$(filename) = "" Then MsgBox "File Not Found.", vbCritical, "basicNES": LoadNES = 0: Exit Function

Close #1

PrgCount = 0: PrgCount2 = 0: ChrCount = 0: ChrCount2 = 0

Open filename For Binary As #1
    Get #1, , Header
    If Header <> "NES" Then
        MsgBox "Invalid Header", vbCritical, "basicNES"
        LoadNES = 0
        Close #1
        Exit Function
    End If
    
    Get #1, 5, PrgCount: PrgCount2 = PrgCount
    Get #1, 6, ChrCount: ChrCount2 = ChrCount
    Debug.Print "[ " & PrgCount & " ] ROM Bank(s)"
    Debug.Print "[ " & ChrCount & " ] CHR Bank(s)"
    
    Get #1, 7, ROMCtrl
    Debug.Print "[ " & ROMCtrl & " ] ROM Control Byte #1"
    Get #1, 8, ROMCtrl2
    Debug.Print "[ " & ROMCtrl2 & " ] ROM Control Byte #2"
    
    Mapper = (ROMCtrl And &HF0) \ 16
    Mapper = Mapper + ROMCtrl2
    
    Debug.Print "[ " & Mapper & " ] Mapper"
    Trainer = ROMCtrl And &H4
    Mirroring = ROMCtrl And &H1
    FourScreen = ROMCtrl And &H8
    If ROMCtrl And &H2 Then UsesSRAM = True
    Debug.Print "Mirroring=" & Mirroring & " Trainer=" & Trainer & " FourScreen=" & FourScreen & " SRAM=" & UsesSRAM
    Dim PrgMark As Long
    PrgMark = (PrgCount2 * &H4000&) - 1
    
    If Trainer Then
        MsgBox "Error: Trainer not yet supported.", vbCritical, VERSION
        LoadNES = 0: Exit Function
    End If
    ReDim gameImage(PrgMark) As Byte
    For i = 0 To PrgMark
        Get #1, i + 17, gameImage(i)
    Next i

    ReDim VROM(ChrCount2 * &H2000&) As Byte
    PrgMark = &H4000& * PrgCount2 + 17
    If ChrCount2 Then
        For i = PrgMark To PrgMark + (ChrCount2 * &H2000&)
           Get #1, i, VROM(i - PrgMark)
        Next i
        AndIt = ChrCount - 1
    End If
    Select Case Mapper
        Case 0, 3
            Select8KVROM 0
            reg8 = 0: regA = 1: regC = &HFE: regE = &HFF
            SetupBanks
        Case 1
            Select8KVROM 0
            reg8 = 0
            regA = 1
            regC = &HFE
            regE = &HFF
            SetupBanks
            sequence = 0: accumulator = 0
            Erase data
            data(0) = &H1F: data(3) = 0
        Case 2
            reg8 = 0
            regA = 1
            regC = &HFE
            regE = &HFF
            SetupBanks
        Case 4
            reg8 = 0
            regA = 1
            regC = &HFE
            regE = &HFF
            SetupBanks
            MMC3_IrqOn = False
            MMC3_IrqVal = 0
            MMC3_TmpVal = 0
            If ChrCount Then Select8KVROM 0
        Case 7
            reg8 = 0
            regA = 1
            regC = 2
            regE = 3
            SetupBanks
        Case 8 'FFE F3xxx
            reg8 = 0: regA = 1
            regC = &HFE: regE = &HFF
            SetupBanks
            Select8KVROM 0
        Case 9 ' MMC2
            reg8 = 0
            regA = &HFD
            regC = &HFE
            regE = &HFF
            SetupBanks
            latch1.hi_bank = 0: latch1.lo_bank = 0: latch1.state = 0
            latch2.hi_bank = 0: latch2.lo_bank = 0: latch2.state = 0
            Select8KVROM 0
        Case 11
            reg8 = 0: regA = 1: regC = 2: regE = 3
            SetupBanks
            Select8KVROM 0
        Case 15
            reg8 = 0
            regA = 1
            regC = 2
            regE = 3
            SetupBanks
        Case 16
            reg8 = 0
            regA = 1
            regC = &HFE
            regE = &HFF
            SetupBanks
        Case 32
            reg8 = 0
            regA = 1
            regC = &HFE
            regE = &HFF
            SetupBanks
        Case 33
            reg8 = 0
            regA = 1
            regC = &HFE
            regE = &HFF
            SetupBanks
        Case 34
            SpecialWrite6000 = True
            reg8 = 0
            regA = 1
            regC = 2
            regE = 3
            SetupBanks
            If ChrCount Then Select8KVROM 0
        Case 40 ' SMB2j [works!]
            Dim ChoseIt As Byte
            ChoseIt = 6
            ChoseIt = MaskBankAddress(ChoseIt)
            Debug.Print ChoseIt
            UsesSRAM = True
            MemCopy bank6(0), gameImage(ChoseIt * &H2000&), &H2000&
            reg8 = &HFC
            regA = &HFD
            regC = &HFE
            regE = &HFF
            SetupBanks
            Select8KVROM 0
            Mapper40_IRQEnabled = 0
            Mapper40_IRQCounter = 0
        Case 66
            reg8 = 0: regA = 1: regC = 2: regE = 3: SetupBanks
            Select8KVROM 0
            SetupBanks
        Case 68
            reg8 = 0: regA = 1: regC = &HFE: regE = &HFF
            Select8KVROM 0
            SetupBanks
            UsesSRAM = True
        Case 69
        Case 71
            reg8 = 0: regA = 1: regC = &HFE: regE = &HFF
            SetupBanks
        Case 78
            regC = &HFE
            regE = &HFF
            SetupBanks
            MMC78_Write 0, 0
        Case 91
            SpecialWrite6000 = True
            reg8 = &HFE
            regA = &HFF
            regC = &HFE
            regE = &HFF
            Select8KVROM 0
            SetupBanks
        Case Else
            MsgBox "Mapper #" & Mapper & " is not supported.", vbCritical, VERSION
            Erase gameImage: Erase VROM
            Close #1: LoadNES = 0: Exit Function
    End Select
    Debug.Print "Successfully loaded " & filename
    reset6502
    If Mirroring = 1 Then MirrorXor = &H800& Else MirrorXor = &H400&
Close #1

CurrentLine = 0
For i = 0 To 7
    Joypad1(i) = &H40
Next i
Frames = 0
CPUPaused = False
ScrollToggle = 1
LoadNES = 1
End Function

Public Sub MMC17_SyncVROM(bank As Integer)
    
    Dim value As Byte
    
    value = bank_regs(bank)
    value = value Or bank_regs(bank + 1) * 16
    
    Select1KVROM bank \ 2, value
    
End Sub
Public Sub MMC23_Write(Address, value As Byte)
    Select Case Address
        Case &H8000&
            reg8 = value
            SetupBanks
        Case &H9000&
             MirrorXor = &H400& * 2 ^ (value And &H3)
        Case &HA000&
            regA = value
            SetupBanks
        'TODO: finish code...
    End Select
End Sub
Public Sub MMC78_Write(Address, value As Byte)
    
    Dim vromptr As Byte, romptr As Byte
    
    vromptr = (value \ &H10&) And &HF
    romptr = value And &HF
    
    Select8KVROM vromptr
    reg8 = (romptr * 2)
    regA = (romptr * 2) + 1
    SetupBanks
    
End Sub
Public Sub MMC1_Write(Address, value As Byte)

Dim bank_select As Integer

If (value And &H80) Then
    data(0) = data(0) Or &HC
    accumulator = data((Address \ &H2000&) And 3)
    sequence = 5
Else
    accumulator = accumulator Or ((value And 1) * (2 ^ sequence))
    sequence = sequence + 1
End If

If (sequence = 5) Then
    data((Address \ &H2000&) And 3) = accumulator
    sequence = 0
    accumulator = 0

    MirrorXor = &H400& * (2 ^ (data(0) And &H3))
            
    If (PrgCount = &H20) Then '/* 512k cart */'
        bank_select = (data(1) And &H10) * 2
    Else '/* other carts */'
        bank_select = 0
    End If
    
    If (data(0) And 8) = 0 Then
        reg8 = ((data(3) And 15) * 4) + bank_select
        regA = ((data(3) And 15) * 4) + bank_select + 1
        regC = ((data(3) And 15) * 4) + bank_select + 2
        regE = ((data(3) And 15) * 4) + bank_select + 3
        SetupBanks
    ElseIf (data(0) And 4) Then
        reg8 = ((data(3) And 15) * 2) + bank_select
        regA = ((data(3) And 15) * 2) + bank_select + 1
        regC = &HFE
        regE = &HFF
        SetupBanks
    Else
        reg8 = 0
        regA = 1
        regC = ((data(3) And 15) * 2) + bank_select
        regE = ((data(3) And 15) * 2) + bank_select + 1
        SetupBanks
    End If
    
    If (data(0) And &H10) Then
        Select4KVROM data(1), 0
        Select4KVROM data(2), 1
    Else
        Select8KVROM data(1) \ 2
    End If
End If

End Sub
Public Sub MMC2Write(Address, value As Byte)
    Select Case Address
        Case &HA000& To &HAFFF&
            reg8 = value
            SetupBanks
        Case &HB000& To &HBFFF&
            latch1.lo_bank = value
            If latch1.state = 0 Then Select4KVROM value, 0
        Case &HC000& To &HCFFF&
            latch1.hi_bank = value
            If latch1.state = 1 Then Select4KVROM value, 0
        Case &HD000& To &HDFFF&
            latch2.lo_bank = value
            If latch2.state = 0 Then Select4KVROM value, 1
        Case &HE000& To &HEFFF&
            latch2.hi_bank = value
            If latch2.state = 1 Then Select4KVROM value, 1
        Case &HF000& To &HFFFF&
            Mirroring = (value And &H1) + 1: MirrorXor = &H400 * (2 ^ Mirroring)
        Case Else: Debug.Print "invalid write to " & Address & "," & value & "."
    End Select
End Sub
Public Sub MMC2_latch(Address)
    If ((Address And &H3FF0) = &HFD0) Then
        latch1.state = 0
        Select4KVROM latch1.lo_bank, 0
    End If
    If ((Address And &H3FF0) = &HFE0) Then
        latch1.state = 1
        Select4KVROM latch1.hi_bank, 1
    End If
    If ((Address And &H3FF0) = &H1FD0) Then
        latch2.state = 0
        Select4KVROM latch2.lo_bank, 0
    End If
    If ((Address And &H3FF0) = &H1FE0) Then
        latch2.state = 1
        Select4KVROM latch2.hi_bank, 1
    End If
End Sub
#If 0 Then
Public Sub DrawScreenNES()
Dim Tile As Byte
Dim X2 As Integer, Y2 As Integer
Dim X1 As Integer, Y1 As Integer
Dim X3 As Integer, Y3 As Integer
Dim Byte1 As Byte, Byte2 As Byte, Color As Integer, Palette As Integer
Dim count As Integer
NameTable = &H2000& + (&H400& * (PPU_Control1 And &H3))
PatternTable = (PPU_Control1 And &H10) * &H100&
count = 0
'If PPU_Control1 And &H8 = 0 Then Exit Sub
For X1 = 0 To 29
    For Y1 = 31 To 0 Step -1
        Tile = VRAM(NameTable + count)
        Dim Anded As Long
        For Y2 = 1 To 8
            Anded = 2 ^ (Y2 - 1)
            For X2 = 1 To 8
                Byte1 = VRAM(PatternTable + (Tile * 16) + X2)
                Byte2 = VRAM(PatternTable + (Tile * 16) + X2 + 8)
                Color = 0
                If (Byte1 And Anded) Then Color = 1
                If (Byte2 And Anded) Then Color = Color + 2
                Palette = ((VRAM((NameTable + &H3C0) + (((currow \ 4) * 8) + (curcol \ 4)))) \ 2 ^ (((((currow And 2) + ((curcol \ 2) And 1))) * 2) And 6)) And 3
                frmNES.picScreen.PSet (255 - (Y1 * 8 + Y2), X1 * 8 + X2), CPal(VRAM(&H3F00 + (Palette * 4) + c1) And &H3F)
            Next X2
        Next Y2
        count = count + 1
    Next Y1
Next X1
DoEvents
frmNES.picScreen.Refresh
End Sub
Public Sub DrawSprites()
'If PPU_Control2 And &H20 Then
    Dim SpritePattern As Integer
    SpritePattern = (PPU_Control1 And &H8) * &H200&
    Dim spr As Integer
    Dim X1 As Byte, Y1 As Byte
    Dim Byte1 As Byte, Byte2 As Byte
    Dim Color As Byte
    SpriteAddr = 0
    
    For spr = 63 To 0 Step -1
        SpriteAddr = spr * 4
        Sprites(spr).X = SpriteRAM(SpriteAddr + 3)
        Sprites(spr).TileNo = SpriteRAM(SpriteAddr + 1)
        Sprites(spr).Attrib = SpriteRAM(SpriteAddr + 2)
        Sprites(spr).Y = SpriteRAM(SpriteAddr)
        For Y1 = 0 To 7
            For X1 = 0 To 7
                Color = 0
                Byte1 = VRAM(SpritePattern + (Sprites(spr).TileNo * 16) + X1)
                Byte2 = VRAM(SpritePattern + (Sprites(spr).TileNo * 16) + X1 + 8)
                If (Byte1 And Table(Y1)) Then Color = 1
                If (Byte2 And Table(Y1)) Then Color = Color + 2
                frmNES.picScreen.PSet (255 - (X1 + Sprites(spr).X), Y1 + Sprites(spr).Y), QBColor(Color)
            Next X1
        Next Y1
    Next spr
'End If
End Sub
Public Sub DrawScreenQb()
Dim Tile As Byte
Dim X2 As Long, Y2 As Long
Dim X1 As Long, Y1 As Long
Dim X3 As Long, Y3 As Long
Dim Byte1 As Byte, Byte2 As Byte, Color As Integer, Palette As Integer
Dim count As Integer
NameTable = &H2000& + (&H400& * (PPU_Control1 And &H3))
PatternTable = (PPU_Control1 And &H10) * &H100&
count = 0
'If PPU_Control1 And &H8 = 0 Then Exit Sub
For X1 = 0 To 29
    For Y1 = 31 To 0 Step -1
        Tile = VRAM(NameTable + count)
        Dim Anded As Long
        'If DirtyChar(count) Then
        For Y2 = 0 To 7
            For X2 = 0 To 7
                Byte1 = VRAM(PatternTable + (Tile * 16) + X2)
                Byte2 = VRAM(PatternTable + (Tile * 16) + X2 + 8)
                Color = 0
                If (Byte1 And Table(Y2)) Then Color = 1
                If (Byte2 And Table(Y2)) Then Color = Color + 2
                frmNES.picScreen.PSet (255 - (Y1 * 8 + Y2), X1 * 8 + X2), QBColor(Color)
            Next X2
        Next Y2
        'End If
        'DirtyChar(count) = 0
        count = count + 1
    Next Y1
Next X1
#If 0 Then
    DrawSprites
#End If
DoEvents
frmNES.picScreen.Refresh
End Sub
#End If
Public Sub LoadPal()
Dim n As Integer
Dim R As Byte, G As Byte, B As Byte
Dim Buff2 As Long
Dim Buff3 As Long
Open App.Path & "\bnes.pal" For Binary As #75
For n = 0 To 63
    Get #75, , R
    Get #75, , G
    Get #75, , B
    Pal(n) = RGB(R, G, B)
Next n
Close #75
End Sub
Function SetPalette(PalNum) As Integer
Select Case PalNum
Case 2
CPal = Array( _
 &H686868, &H804000, &H800000, &H800040, &H800080, &H400080, &H80, &H55, _
    &H4040, &H5033, &H5000, &H5000, &H404000, &H0, &H0, &H0, _
    &H989898, &HC08000, &HC04040, &HC00080, &HC000C0, &H8000C0, &H2020C0, &H40C0, _
    &H8080, &H8055, &H8000, &H338033, &H808000, &H0, &H0, &H0, _
    &HD0D0D0, &HFFC040, &HFF8080, &HFF40C0, &HFF00FF, &HC040FF, &H5050FF, &H4080FF, _
    &HC0C0, &HC080, &HC000, &H55C055, &HC0C000, &H333333, &H0, &H0, _
    &HFFFFFF, &HFFFF80, &HFFC0C0, &HFF80FF, &HFF40FF, &HFF80FF, &H8080FF, &H80C0FF, _
    &H40FFFF, &H40FFC0, &H40FF40, &HAAFFAA, &HFFFF40, &H999999, &H0, &H0 _
)
Case 1
    '*** Alex Krasivsky's Palette ***'
    CPal = Array(RGB(&H68, &H68, &H68), RGB(&H0, &H40, &H80), RGB(&H0, &H0, &H80), RGB(&H40, &H0, &H80), _
    RGB(&H80, &H0, &H80), RGB(&H80, &H0, &H40), RGB(&H80, &H0, &H0), RGB(&H55, &H0, &H0), _
    RGB(&H40, &H40, &H0), RGB(&H33, &H50, &H0), RGB(&H0, &H50, &H0), RGB(&H0, &H50, &H0), _
    RGB(&H0, &H40, &H40), RGB(&H0, &H0, &H0), RGB(&H0, &H0, &H0), RGB(&H0, &H0, &H0), _
    RGB(&H98, &H98, &H98), RGB(&H0, &H80, &HC0), RGB(&H40, &H40, &HC0), RGB(&H80, &H0, &HC0), _
    RGB(&HC0, &H0, &HC0), RGB(&HC0, &H0, &H80), RGB(&HC0, &H20, &H20), RGB(&HC0, &H40, &H0), _
    RGB(&H80, &H80, &H0), RGB(&H55, &H80, &H0), RGB(&H0, &H80, &H0), RGB(&H33, &H80, &H33), _
    RGB(&H0, &H80, &H80), RGB(&H0, &H0, &H0), RGB(&H0, &H0, &H0), RGB(&H0, &H0, &H0), _
    RGB(&HD0, &HD0, &HD0), RGB(&H40, &HC0, &HFF), RGB(&H80, &H80, &HFF), RGB(&HC0, &H40, &HFF), _
    RGB(&HFF, &H0, &HFF), RGB(&HFF, &H40, &HC0), RGB(&HFF, &H50, &H50), RGB(&HFF, &H80, &H40), _
    RGB(&HC0, &HC0, &H0), RGB(&H80, &HC0, &H0), RGB(&H0, &HC0, &H0), RGB(&H55, &HC0, &H55), _
    RGB(&H0, &HC0, &HC0), RGB(&H33, &H33, &H33), RGB(&H0, &H0, &H0), RGB(&H0, &H0, &H0), _
    RGB(&HFF, &HFF, &HFF), RGB(&H80, &HFF, &HFF), RGB(&HC0, &HC0, &HFF), RGB(&HFF, &H80, &HFF), _
    RGB(&HFF, &H40, &HFF), RGB(&HFF, &H80, &HFF), RGB(&HFF, &H80, &H80), RGB(&HFF, &HC0, &H80), _
    RGB(&HFF, &HFF, &H40), RGB(&HC0, &HFF, &H40), RGB(&H40, &HFF, &H40), RGB(&HAA, &HFF, &HAA), _
    RGB(&H40, &HFF, &HFF), RGB(&H99, &H99, &H99), RGB(&H0, &H0, &H0), RGB(&H0, &H0, &H0))
SetPalette = 1
'Debug.Print "SetPalette() Successful"
Case 3
    ' Matt Conte's perfect palette
   CPal = Array(RGB(&H7F, &H7F, &H7F), RGB(&H0, &H0, &HBB), RGB(&H37, &H0, &HBF), RGB(&H84, &H0, &HA6), _
   RGB(&HBB, &H0, &H6A), RGB(&HB7, &H0, &H22), RGB(&HB3, &H1E, &H0), RGB(&H91, &H26, &H0), _
   RGB(&H7B, &H2B, &H0), RGB(&H0, &H44, &H0), RGB(&H0, &H48, &HD), RGB(&H0, &H59, &H48), _
   RGB(&H0, &H48, &H91), RGB(&H0, &H0, &H0), RGB(&H5, &H5, &H5), RGB(&H5, &H5, &H5), _
   RGB(&HC8, &HC8, &HC8), RGB(&H0, &H59, &HFF), RGB(&H66, &H0, &HFF), RGB(&HB7, &H33, &HCC), _
   RGB(&HFF, &H33, &H8C), RGB(&HFF, &H3C, &H5E), RGB(&HFF, &H37, &H1A), RGB(&HD5, &H4B, &H0), _
   RGB(&HC4, &H62, &H0), RGB(&H59, &H7B, &H0), RGB(&H1E, &H84, &H15), RGB(&H0, &H95, &H7B), _
   RGB(&H0, &H99, &HD9), RGB(&H11, &H11, &H11), RGB(&H9, &H9, &H9), RGB(&H9, &H9, &H9), _
   RGB(&HFF, &HFF, &HFF), RGB(&H0, &HAA, &HFF), RGB(&H80, &H80, &HFF), RGB(&HD5, &H6F, &HFF), _
   RGB(&HFF, &H77, &HC4), RGB(&HFF, &H77, &H99), RGB(&HFF, &H7B, &H62), RGB(&HFF, &H8C, &H59), _
   RGB(&HFF, &HA2, &H2B), RGB(&HBB, &HC8, &H0), RGB(&H51, &HD9, &H6A), RGB(&H4D, &HD5, &HAE), _
   RGB(&H15, &HEA, &HFF), RGB(&H66, &H66, &H66), RGB(&HD, &HD, &HD), RGB(&HD, &HD, &HD), _
   RGB(&HFF, &HFF, &HFF), RGB(&HAE, &HC8, &HFF), RGB(&HBB, &HBB, &HFF), RGB(&HDD, &HB3, &HEA), _
   RGB(&HFF, &HB7, &HEA), RGB(&HFF, &HB3, &HCC), RGB(&HFF, &HC4, &HB7), RGB(&HFF, &HCC, &HAE), _
   RGB(&HFF, &HD9, &HA2), RGB(&HCC, &HE1, &H99), RGB(&HAE, &HEE, &HB7), RGB(&HAA, &HF2, &HCC), _
   RGB(&HA2, &HEE, &HFF), RGB(&HDD, &HDD, &HDD), RGB(&H11, &H11, &H11), RGB(&H11, &H11, &H11))
   SetPalette = 1
End Select
End Function
